//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.8-b130911.1802 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2016.04.15 at 02:17:08 PM CEST 
//


package org.oasis.xliff;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyAttribute;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElements;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{urn:oasis:names:tc:xliff:document:1.2}bin-source"/>
 *         &lt;element ref="{urn:oasis:names:tc:xliff:document:1.2}bin-target" minOccurs="0"/>
 *         &lt;choice maxOccurs="unbounded" minOccurs="0">
 *           &lt;element ref="{urn:oasis:names:tc:xliff:document:1.2}context-group"/>
 *           &lt;element ref="{urn:oasis:names:tc:xliff:document:1.2}count-group"/>
 *           &lt;element ref="{urn:oasis:names:tc:xliff:document:1.2}prop-group"/>
 *           &lt;element ref="{urn:oasis:names:tc:xliff:document:1.2}note"/>
 *           &lt;element ref="{urn:oasis:names:tc:xliff:document:1.2}trans-unit"/>
 *         &lt;/choice>
 *         &lt;any processContents='skip' namespace='##other' maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="id" use="required" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="mime-type" use="required" type="{urn:oasis:names:tc:xliff:document:1.2}mime-typeValueList" />
 *       &lt;attribute name="approved" type="{urn:oasis:names:tc:xliff:document:1.2}AttrType_YesNo" />
 *       &lt;attribute name="translate" type="{urn:oasis:names:tc:xliff:document:1.2}AttrType_YesNo" default="yes" />
 *       &lt;attribute name="reformat" type="{urn:oasis:names:tc:xliff:document:1.2}AttrType_reformat" default="yes" />
 *       &lt;attribute name="ts" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="restype" type="{urn:oasis:names:tc:xliff:document:1.2}AttrType_restype" />
 *       &lt;attribute name="resname" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="phase-name" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;anyAttribute processContents='skip'/>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "binSource",
    "binTarget",
    "contextGroupOrCountGroupOrPropGroup",
    "any"
})
@XmlRootElement(name = "bin-unit")
public class BinUnit {

    @XmlElement(name = "bin-source", required = true)
    protected BinSource binSource;
    @XmlElement(name = "bin-target")
    protected BinTarget binTarget;
    @XmlElements({
        @XmlElement(name = "context-group", type = ContextGroup.class),
        @XmlElement(name = "count-group", type = CountGroup.class),
        @XmlElement(name = "prop-group", type = PropGroup.class),
        @XmlElement(name = "note", type = Note.class),
        @XmlElement(name = "trans-unit", type = TransUnit.class)
    })
    protected List<Object> contextGroupOrCountGroupOrPropGroup;
    @XmlAnyElement
    protected List<Element> any;
    @XmlAttribute(name = "id", required = true)
    protected String id;
    @XmlAttribute(name = "mime-type", required = true)
    protected String mimeType;
    @XmlAttribute(name = "approved")
    protected AttrTypeYesNo approved;
    @XmlAttribute(name = "translate")
    protected AttrTypeYesNo translate;
    @XmlAttribute(name = "reformat")
    protected List<String> reformat;
    @XmlAttribute(name = "ts")
    protected String ts;
    @XmlAttribute(name = "restype")
    protected String restype;
    @XmlAttribute(name = "resname")
    protected String resname;
    @XmlAttribute(name = "phase-name")
    protected String phaseName;
    @XmlAnyAttribute
    private Map<QName, String> otherAttributes = new HashMap<QName, String>();

    /**
     * Gets the value of the binSource property.
     * 
     * @return
     *     possible object is
     *     {@link BinSource }
     *     
     */
    public BinSource getBinSource() {
        return binSource;
    }

    /**
     * Sets the value of the binSource property.
     * 
     * @param value
     *     allowed object is
     *     {@link BinSource }
     *     
     */
    public void setBinSource(BinSource value) {
        this.binSource = value;
    }

    /**
     * Gets the value of the binTarget property.
     * 
     * @return
     *     possible object is
     *     {@link BinTarget }
     *     
     */
    public BinTarget getBinTarget() {
        return binTarget;
    }

    /**
     * Sets the value of the binTarget property.
     * 
     * @param value
     *     allowed object is
     *     {@link BinTarget }
     *     
     */
    public void setBinTarget(BinTarget value) {
        this.binTarget = value;
    }

    /**
     * Gets the value of the contextGroupOrCountGroupOrPropGroup property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the contextGroupOrCountGroupOrPropGroup property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getContextGroupOrCountGroupOrPropGroup().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ContextGroup }
     * {@link CountGroup }
     * {@link PropGroup }
     * {@link Note }
     * {@link TransUnit }
     * 
     * 
     */
    public List<Object> getContextGroupOrCountGroupOrPropGroup() {
        if (contextGroupOrCountGroupOrPropGroup == null) {
            contextGroupOrCountGroupOrPropGroup = new ArrayList<Object>();
        }
        return this.contextGroupOrCountGroupOrPropGroup;
    }

    /**
     * Gets the value of the any property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the any property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAny().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Element }
     * 
     * 
     */
    public List<Element> getAny() {
        if (any == null) {
            any = new ArrayList<Element>();
        }
        return this.any;
    }

    /**
     * Gets the value of the id property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setId(String value) {
        this.id = value;
    }

    /**
     * Gets the value of the mimeType property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getMimeType() {
        return mimeType;
    }

    /**
     * Sets the value of the mimeType property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMimeType(String value) {
        this.mimeType = value;
    }

    /**
     * Gets the value of the approved property.
     * 
     * @return
     *     possible object is
     *     {@link AttrTypeYesNo }
     *     
     */
    public AttrTypeYesNo getApproved() {
        return approved;
    }

    /**
     * Sets the value of the approved property.
     * 
     * @param value
     *     allowed object is
     *     {@link AttrTypeYesNo }
     *     
     */
    public void setApproved(AttrTypeYesNo value) {
        this.approved = value;
    }

    /**
     * Gets the value of the translate property.
     * 
     * @return
     *     possible object is
     *     {@link AttrTypeYesNo }
     *     
     */
    public AttrTypeYesNo getTranslate() {
        if (translate == null) {
            return AttrTypeYesNo.YES;
        } else {
            return translate;
        }
    }

    /**
     * Sets the value of the translate property.
     * 
     * @param value
     *     allowed object is
     *     {@link AttrTypeYesNo }
     *     
     */
    public void setTranslate(AttrTypeYesNo value) {
        this.translate = value;
    }

    /**
     * Gets the value of the reformat property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the reformat property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getReformat().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link String }
     * 
     * 
     */
    public List<String> getReformat() {
        if (reformat == null) {
            reformat = new ArrayList<String>();
        }
        return this.reformat;
    }

    /**
     * Gets the value of the ts property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTs() {
        return ts;
    }

    /**
     * Sets the value of the ts property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTs(String value) {
        this.ts = value;
    }

    /**
     * Gets the value of the restype property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getRestype() {
        return restype;
    }

    /**
     * Sets the value of the restype property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setRestype(String value) {
        this.restype = value;
    }

    /**
     * Gets the value of the resname property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getResname() {
        return resname;
    }

    /**
     * Sets the value of the resname property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setResname(String value) {
        this.resname = value;
    }

    /**
     * Gets the value of the phaseName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPhaseName() {
        return phaseName;
    }

    /**
     * Sets the value of the phaseName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPhaseName(String value) {
        this.phaseName = value;
    }

    /**
     * Gets a map that contains attributes that aren't bound to any typed property on this class.
     * 
     * <p>
     * the map is keyed by the name of the attribute and 
     * the value is the string value of the attribute.
     * 
     * the map returned by this method is live, and you can add new attribute
     * by updating the map directly. Because of this design, there's no setter.
     * 
     * 
     * @return
     *     always non-null
     */
    public Map<QName, String> getOtherAttributes() {
        return otherAttributes;
    }

}
